//+------------------------------------------------------------------+
//|                                         V1.mq4 |
//                                                
//             

#property copyright ""
#property link      ""

int     timeframe      = 0;
double  stopLoss       = 1000; 
extern double  TakeProfit     = 27;
string  Name_Expert    = "V1";
int     Slippage       = 10;
bool    UseSound       = false;
string  NameFileSound  = "alert.wav";
double  InitLots           = 0.01;
extern double Multiplier =2;
extern int D=20;
extern int MaxTrades       =20; //EURUSD H1 best
double MaxLot          =1;
extern int SL=20;
double  s=0;
int T,B,c;
int PercentForProtection=100; // Modify HERE the percent for profit protection!!!
int ac=463552;                // Modify the account number as you like!
int expday=1;                 // Modify the expiry day as you like! It will stop working on this day.
int expmonth=12;              // Modify the expiry month as you like!
int expyear=2006;             // Modify the expiry year as you like!
double Lots,Long,Short,P,I,X,Y;
double Last=EMPTY_VALUE;  
int init(){return(0);}

int deinit(){return(0);}

int start(){


   if(Bars<100)   {Print("bars less than 100");return(0);}
   
   if(timeframe==0) {timeframe=Period();}

double   Price=iClose(NULL,0,0);
double RSI=iClose(NULL,0,1);
double RS1=iOpen(NULL,0,1);

if (!ExistPositions()) s=0;


int T=0;  
  for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) 
         {  T++;
            if(OrderType()==OP_BUY) s=1;
            if(OrderType()==OP_SELL) s=2;
            Last=OrderOpenPrice();
         }}

InitLots=MathCeil(AccountBalance()/6000)/100;
Lots=InitLots;
Lots=MathFloor(Lots*100)/100;
if (Lots<0.01) Lots=0.01;


stopLoss=SL+(MaxTrades-1)*D;
if (Lots<0.01) Lots=0.01;
for (int j=0;j<T;j++) {Lots=Multiplier*Lots; stopLoss=stopLoss-D; }

if (AccountBalance()>6000) MaxLot=MathFloor(AccountBalance()/40)/100;
if (Lots>MaxLot) Lots=MaxLot; 

if (Lots>100) Lots=100; 
if (Lots<0.01) Lots=0.01;


if (T==0) { Long=1000; Short=-1000;}
if (Long==0) Long=1000;
if (Short==0) Short=-1000;


if (T>0)
{
if ((s==1)&&(Long>Last)) Long=Last;
if ((s==2)&&(Short<Last)) Short=Last;
}

if (T==MaxTrades) c=1;
if (T==0) c=0;


if (s==0)    if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);  }

double spread=(Ask-Bid)/Point;
Print("Spread=",spread,"; c=",c);


X=0;Y=0;

if ((s==0)&&(X==0)&&(Y==0)&&(c==0))  {OpenBuy();s=1; return(0);}  


if (T<MaxTrades) {

  if ((s==1)&&(Price<(Last-(D+spread)*Point))&&(c==0))       {OpenBuy();s=1; return(0);}
 
  if ((s==2)&&(Price>(Last+(D)*Point))&&(c==0))                {OpenSell();s=2; return(0);}
  
  if ((s==1)&&(Price>(Long+(TakeProfit-1)*Point)))              {closeAllOrders();s=0; return(0);}
 
  if ((s==2)&&(Price<(Short-(TakeProfit-1+spread)*Point)))      {closeAllOrders();s=0; return(0);} 

  }
  
    
return (0); }//end start




// - - - - - - FUNCTIONS - - - - - - -
 

bool ExistPositions()   {
   for(int i=0;i<OrdersTotal(); i++)  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) return(True);
         else return(false); }   }
/*
void TrailingPositionsBuy(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) { 
            if(OrderType()==OP_BUY) { 
               if(Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if(OrderStopLoss()<Bid-trailingStop*Point || OrderStopLoss()==0)   {
                     ModifyStopLoss(Bid-trailingStop*Point); }}}}}} 

void TrailingPositionsSell(int trailingStop) { 
   for(int i=0;i<OrdersTotal();i++) { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) { 
            if(OrderType()==OP_SELL) { 
               if(OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if(OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  {  
                     ModifyStopLoss(Ask+trailingStop*Point);}}}}}} 
 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,0); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 
*/
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Ask-Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitBuy(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,NormalizeDouble(Ask,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Blue); 
   if (UseSound) PlaySound(NameFileSound);   }
 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = Bid+Point*stopLoss; 
   ldTake = NormalizeDouble(GetTakeProfitSell(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,NormalizeDouble(Bid,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Red); 
   if (UseSound) PlaySound(NameFileSound);   }

// close all open and pending orders

void closeAllOrders()  {
   for(int c=0;c<OrdersTotal();c++) {
     OrderSelect(c,SELECT_BY_POS,MODE_TRADES); 
         if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType()==OP_BUY)  {
            OrderClose(OrderTicket(), OrderLots(),Bid,Slippage, White);  }
         if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType()==OP_SELL)  {
            OrderClose(OrderTicket(), OrderLots(), Ask,Slippage, White);  }   
         if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType() > 1)  { OrderDelete(OrderTicket()); }
   }
} 

// end closeAllOrders() 

string GetCommentForOrder() { return(Name_Expert); } 
double GetSizeLot() { return(Lots); } 
double GetTakeProfitBuy() { return(Ask+TakeProfit*Point); } 
double GetTakeProfitSell() { return(Bid-TakeProfit*Point); } 